.TH XvQueryExtension 3X __vendorversion__
.\" $XFree86: xc/doc/man/Xv/XvQueryExtension.man,v 1.5 2001/01/27 18:20:36 dawes Exp $
.SH Name
XvQueryExtension \- return version and release of extension
.\"
.SH Syntax
.B #include <X11/extensions/Xvlib.h> 
.sp 1l
\fBXvQueryExtension(\fIp_version, p_release, 
.br
	p_request_base, p_event_base, p_error_base\fR)
.sp 1l
\fBunsigned int *p_version, *p_release;
\fBunsigned int *p_request_base, *p_event_base, *p_error_base;
.\"
.SH Arguments
.\"
.IP \fIp_version\fR 15
Pointer to where the current version number of the \fIXv\fP video extension
is written.
.IP \fIp_release\fR 15
Pointer to where the release number of the \fIXv\fP video extension
is written.
.IP \fIp_request_base\fR 15
Pointer to where the extension major request number is returned
.IP \fIp_event_base\fR 15
Pointer to where the extension event base is returned
.IP \fIp_error_base\fR 15
Pointer to where the extension error base is returned
.\"
.SH Description
.\"
.PP
XvQueryExtension(3X) returns the version and release
numbers for the Xv video extension currently loaded 
on the system.  The extension major request number, event base, and error
base are also returned.
.\"
.SH Returned Values
.IP [Success] 8
Returns True if XvQueryExtension(3X) completed successfully.
.IP [XvBadExtension] 8
Returned if the Xv video extension is not available for 
the named display.
.IP [XvBadAlloc] 8
Returned if XvQueryExtension(3X) failed to allocate memory to process
the request.
.br
