.\" $XFree86: xc/programs/Xserver/hw/kdrive/vesa/Xvesa.man,v 1.6 2001/01/27 18:20:40 dawes Exp $
.TH Xvesa 1 __vendorversion__
.SH NAME
Xvesa \- VESA Bios Extensions tiny X server
.SH SYNOPSIS
.B Xvesa
.RI [ :display ] 
.RI [ option ...]
.SH DESCRIPTION
.B Xvesa
is a generic X server for Linux on the x86 platform.  
.B Xvesa
doesn't know about any particular hardware, and sets the video mode by
running the video BIOS in VM86 mode.
.B Xvesa
can use both standard VGA BIOS modes and any modes advertised by a
VESA BIOS if available.
.B Xvesa
runs untrusted code with full privileges, and is therefore a fairly
insecure X server.
.B Run at your own risk.
.SH OPTIONS
In addition to the normal KDrive server's options (see Xkdrive(1)),
.B Xvesa
accepts the following command line switches:
.TP 8
.B -mode \fIn\fB
specifies the VESA video mode to use.  If mode
.I n
is not supported by your BIOS and hardware,
.B Xvesa
will fail, hang your system, or cause your monitor to explode; you are
on your own.  This option overrides any
.B -screen
options.
.TP 8
.B -listmodes
list all supported video modes.  If
.B -force
was specified before
.BR -listmodes ,
lists all the modes that your BIOS claims to support, even those that
the
.B Xvesa
server won't be able to use.
.TP 8
.B -force
disable some sanity checks and use the specified mode even if the
BIOS claims not to support it.
.TP 8
.B -shadow
use a shadow framebuffer even if it is not strictly necessary.  This
may dramatically improve performance on some hardware.
.TP 8
.B -nolinear
don't use a linear framebuffer even if one is available.  You don't
want to use this option.
.TP 8
.B -swaprgb
pass RGB values in the order that works on broken BIOSes.  Use this if
the colours are wrong in PseudoColor and 16 colour modes.
.TP 8
.B -verbose
emit diagnostic messages during BIOS initialization and teardown.
.SH KEYBOARD
To be written.
.SH BUGS
.B Xvesa
opens all IO ports and runs your VESA BIOS, which may be assumed to be
buggy.  Allowing your users to run
.B Xvesa
is probably a security hole.

.B Xvesa
records the current BIOS mode when it starts and restores that mode on
termination; if the video card has been reprogrammed by another application,
the display will almost certainly be trashed.  The alternative of saving and
restoring the complete video card state has proven unreliable on most video
cards.
.SH SEE ALSO
X(__miscmansuffix__), Xserver(1), Xkdrive(1), xdm(1), xinit(1).
.SH AUTHORS
The VESA driver was written by Juliusz Chroboczek who didn't realise
what he was doing until it was too late.  Keith Packard then added
support for standard VGA BIOS modes and is especially proud of 320x200
16 colour mode.
