.\" $Xorg: xlogo.man,v 1.3 2000/08/17 19:54:52 cpqbld Exp $
.\" Copyright 1988, 1994, 1998  The Open Group
.\" 
.\" All Rights Reserved.
.\" 
.\" The above copyright notice and this permission notice shall be included
.\" in all copies or substantial portions of the Software.
.\" 
.\" THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
.\" OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
.\" MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
.\" IN NO EVENT SHALL THE OPEN GROUP BE LIABLE FOR ANY CLAIM, DAMAGES OR
.\" OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
.\" ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
.\" OTHER DEALINGS IN THE SOFTWARE.
.\" 
.\" Except as contained in this notice, the name of The Open Group shall
.\" not be used in advertising or otherwise to promote the sale, use or
.\" other dealings in this Software without prior written authorization
.\" from The Open Group.
.\"
.\" $XFree86: xc/programs/xlogo/xlogo.man,v 1.7 2001/01/27 18:21:17 dawes Exp $
.\"
.TH XLOGO 1 __xorgversion__
.SH NAME
xlogo - X Window System logo
.SH SYNOPSIS
.B xlogo
[-\fItoolkitoption\fP ...]
.SH DESCRIPTION
The \fIxlogo\fP program displays the X Window System logo.
.SH OPTIONS
.I Xlogo
accepts all of the standard X Toolkit command line options, as well as the
following:
.TP 8
.B \-shape
This option indicates that the logo window should be shaped rather than
rectangular.
.SH RESOURCES
The default width and the default height are each 100 pixels.
This program uses the \fILogo\fP widget in the Athena widget set.  It
understands all of the Simple widget resource names and classes as well as:
.TP 8
.B foreground (\fPclass\fB Foreground)
Specifies the color for the logo.  The default is depends on whether
\fIreverseVideo\fP is specified.  If \fIreverseVideo\fP is specified
the default is \fIXtDefaultForeground\fP, otherwise the default is 
\fIXtDefaultBackground\fP.
.TP 8
.B shapeWindow (\fPclass\fB ShapeWindow) 
Specifies that the window is shaped to the X logo.  The default is False.
.SH WIDGETS
In order to specify resources, it is useful to know the hierarchy of
the widgets which compose \fIxlogo\fR.  In the notation below,
indentation indicates hierarchical structure.  The widget class name
is given first, followed by the widget instance name.
.sp
.nf
.TA .5i 
.ta .5i 
XLogo  xlogo
	Logo  xlogo
.fi
.sp
.SH ENVIRONMENT
.TP 8
.B DISPLAY
to get the default host and display number.
.TP 8
.B XENVIRONMENT
to get the name of a resource file that overrides the global resources
stored in the RESOURCE_MANAGER property.
.SH FILES
<XRoot>/lib/X11/app-defaults/XLogo - specifies required resources
.SH SEE ALSO
X(__miscmansuffix__), xrdb(1)
.SH AUTHORS
Ollie Jones of Apollo Computer and Jim Fulton of the MIT X Consortium
wrote the logo graphics routine, based on a graphic design by Danny
Chong and Ross Chapman of Apollo Computer.
